// HW1.CPP -- uses lots of keywords and the fstream class
// Jim Fawcett, CSE687

#include <fstream.h>           // fstream includes iostream
#include <stdlib.h>            // defines exit

//----< static int line_count(char *file_name) >---------------
//      counts the number of lines in a text file

static int line_count(char *file_name) {

  #define MAXSIZE 256
  char line[MAXSIZE];  int ch, count = 0;
  ifstream istrm(file_name);   // try to open file
  if (!istrm) {                // in new stream instance
    cerr << "can't open " << file_name << "\n";
    exit(1);
  }
  while (istrm) {
    istrm.get(line,MAXSIZE);   // read line up to "\n"
    ch = istrm.get();          // read next char
    if (ch == '\n')
      ++count;
    else if (ch == EOF)
      if (line[0] == '\0')
	return count;
      else
	return ++count;
    else
      break;
  }
  cerr << "error in ifstream get()\n";
  exit(1);
}
/**/
//----< int main(int argc, char *argv[]) >---------------------
//      does a few, not very useful, things

int main(int argc, char *argv[]) {

  if (argc < 2) {              // argc counts number of argv's
    cerr << "please enter file name on command line\n";
    return 1;
  }
  ifstream istrm(argv[1]);
  if (!istrm) {       // istrm will be null if can't open file
    cerr << "can't open " << argv[1] << "\n";
    return 1;
  }

  char ch;
  cout << "This is file " << argv[1]
       << " \nProcessed by " << argv[0] << "\n\n";
  while (istrm.get(ch))        // copy input file to standard output
    cout.put(ch);
  cout << "\n\n";
  cout << "It has " << line_count(argv[1]) << " lines\n\n";

  #define NUM_DIGITS 10
  cout << "counting digits:\n   ";
  char *alphas[NUM_DIGITS] = { "zero  ", "one   ", "two   ", "three ",
			       "four  ", "five  ", "six   ", "seven ",
			       "eight ", "nine\n" };
  for (int i=0; i<NUM_DIGITS; i++ )
    cout << alphas[i];
  i = 0;
  do {
    if (i++ == 0)              // increment after compare
      cout << "  ";
    else
      cout << "+-----";
  } while (i<NUM_DIGITS+1);    // which binds tigher, < or + ?
  cout << "+\n\n";
  return 0;
}
